package com.univ.abacomaya;

import com.univ.abacomaya.interfaces.FindView;
import com.univ.abacomaya.interfaces.TableParameters;
import com.univ.abacomaya.logic.Util;
import com.univ.abacomaya.logic.UtilDivision;

import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;

public class Fragment4 extends Fragment {
	
     @Override
	 public View onCreateView(final LayoutInflater inflater, final ViewGroup container, Bundle savedInstanceState) {
	        View view = inflater.inflate(R.layout.fm4, container, false);

            Constant.currentFragment=4;
	      
            FindView.findViewF4(view);
            TableParameters.checkbox.setChecked(Constant.showDialog);
    	    
            
	        //Setta le dimensioni della tabella in base al Display
	        TableParameters.setTableDimensionMoltiplication(getActivity());
	        
	        //Setta di default il Caracol
	        Util.setAddButton(0);
	        
	        //setta il metodo onClick
		    TableParameters.rlr_2v4.setOnClickListener(l);
		    TableParameters.rlr_2v3.setOnClickListener(l);
		    TableParameters.rlr_2v2.setOnClickListener(l);
		    TableParameters.rlr_2v1.setOnClickListener(l);
		    TableParameters.rlr_h4.setOnClickListener(l);
		    TableParameters.rlr_h3.setOnClickListener(l);
		    TableParameters.rlr_h2.setOnClickListener(l);
		    TableParameters.rlr_h1.setOnClickListener(l);
		     
		     //setta il metodo OnLongClick
		     TableParameters.rlr_2v4.setOnLongClickListener(l2);
		     TableParameters.rlr_2v3.setOnLongClickListener(l2);
		     TableParameters.rlr_2v2.setOnLongClickListener(l2);
		     TableParameters.rlr_2v1.setOnLongClickListener(l2);
		     TableParameters.rlr_h4.setOnLongClickListener(l2);
		     TableParameters.rlr_h3.setOnLongClickListener(l2);
		     TableParameters.rlr_h2.setOnLongClickListener(l2);
		     TableParameters.rlr_h1.setOnLongClickListener(l2);
		    
		     
		        //Comandi dei bottoni cursori 
		        TableParameters.btn_palito.setOnClickListener(new OnClickListener(){
	            @Override
				public void onClick(View v) {
	            Util.setAddButton(5);      }});
		        TableParameters.btn_frijolito.setOnClickListener(new OnClickListener(){
		        @Override
				public void onClick(View v) {
		        Util.setAddButton(1);       }});
		        TableParameters.btn_caracol.setOnClickListener(new OnClickListener(){
		        @Override
				public void onClick(View v) {
		        Util.setAddButton(0);       }});
		        TableParameters.btn_minus.setOnClickListener(new OnClickListener(){
				@Override
				public void onClick(View v) {
				Util.setAddButton(-1);      }});
		        
		        
		        TableParameters.checkbox.setOnClickListener(new OnClickListener(){
		 	  	   @Override
		 	  	   public void onClick(View v) {
		 	  	   if (TableParameters.checkbox.isChecked()) {
		 	  		Constant.showDialog=true;    }
		 	  	   else {
		 	  		Constant.showDialog=false;     }
		            }});
		        
		        //comandi dei bottoni di calcolo 
		        TableParameters.btn_calc.setOnClickListener(new OnClickListener(){
		        @Override
				public void onClick(View v) {
		        UtilDivision.div(getActivity().getBaseContext());  }});
			    TableParameters.btn_pstep.setOnClickListener(new OnClickListener(){
				@Override
				public void onClick(View v) {
				Util.prevStep();      }});
				TableParameters.btn_sstep.setOnClickListener(new OnClickListener(){
				@Override
				public void onClick(View v) {
				Util.nextStep();     }});

	       
	  return view;
    }
	 
		//TODO
		private OnClickListener l = new OnClickListener(){
		     @Override
			 public void onClick(View v) {
			 switch(v.getId()){
			 
			 case R.id.rlr_2v4:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v4s>=5){
					Util.setButton(true,TableParameters.rlr_2v4, Constant.v4s);
					Constant.v4s = Constant.v4s+0;}
					else if(Constant.currentValue==1&&Constant.v4s>=9){
					Util.setButton(true,TableParameters.rlr_2v4, Constant.v4s);
					Constant.v4s = Constant.v4s+0;}
					else if(Constant.currentValue==-1&&Constant.v4s==0){
					Util.setButton(true,TableParameters.rlr_2v4, 0);
					Constant.v4s = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_2v4, Constant.v4s+Constant.currentValue);
					Constant.v4s = Constant.v4s+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_2v4,0);
					 Constant.v4s = Constant.v4s+Constant.currentValue;
					 } break;
					 
				 
			 case R.id.rlr_2v3:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v3s>=5){
					Util.setButton(true,TableParameters.rlr_2v3, Constant.v3s);
					Constant.v3s = Constant.v3s+0;}
					else if(Constant.currentValue==1&&Constant.v3s>=9){
					Util.setButton(true,TableParameters.rlr_2v3, Constant.v3s);
					Constant.v3s = Constant.v3s+0;}
					else if(Constant.currentValue==-1&&Constant.v3s==0){
					Util.setButton(true,TableParameters.rlr_2v3, 0);
					Constant.v3s = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_2v3, Constant.v3s+Constant.currentValue);
					Constant.v3s = Constant.v3s+Constant.currentValue;}
				 } else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_2v3,0);
					 Constant.v3s = Constant.v3s+Constant.currentValue;
					 } break;
				 
			 case R.id.rlr_2v2:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v2s>=5){
					Util.setButton(true,TableParameters.rlr_2v2, Constant.v2s);
					Constant.v2s = Constant.v2s+0;}
					else if(Constant.currentValue==1&&Constant.v2s>=9){
					Util.setButton(true,TableParameters.rlr_2v2, Constant.v2s);
					Constant.v2s = Constant.v2s+0;}
					else if(Constant.currentValue==-1&&Constant.v2s==0){
					Util.setButton(true,TableParameters.rlr_2v2, 0);
					Constant.v2s = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_2v2, Constant.v2s+Constant.currentValue);
					Constant.v2s = Constant.v2s+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_2v2,0);
					 Constant.v2s = Constant.v2s+Constant.currentValue;
					 } break;
				 
			 case R.id.rlr_2v1:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v1s>=5){
					Util.setButton(true,TableParameters.rlr_2v1, Constant.v1s);
					Constant.v1s = Constant.v1s+0;}
					else if(Constant.currentValue==1&&Constant.v1s>=9){
					Util.setButton(true,TableParameters.rlr_2v1, Constant.v1s);
					Constant.v1s = Constant.v1s+0;}
					else if(Constant.currentValue==-1&&Constant.v1s==0){
					Util.setButton(true,TableParameters.rlr_2v1, 0);
					Constant.v1s = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_2v1, Constant.v1s+Constant.currentValue);
					Constant.v1s = Constant.v1s+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_2v1,0);
					 Constant.v1s = Constant.v1s+Constant.currentValue;
					 } break;
				 
				 
			 case R.id.rlr_h4:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v4>=5){
					Util.setButton(true,TableParameters.rlr_h4, Constant.v4);
					Constant.v4 = Constant.v4+0;}
					else if(Constant.currentValue==1&&Constant.v4>=9){
					Util.setButton(true,TableParameters.rlr_h4, Constant.v4);
					Constant.v4 = Constant.v4+0;}
					else if(Constant.currentValue==-1&&Constant.v4==0){
					Util.setButton(true,TableParameters.rlr_h4, 0);
					Constant.v4 = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_h4, Constant.v4+Constant.currentValue);
					Constant.v4 = Constant.v4+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_h4,0);
					 Constant.v4 = Constant.v4+Constant.currentValue;
					 } break;
				 
			 case R.id.rlr_h3:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v3>=5){
					Util.setButton(true,TableParameters.rlr_h3, Constant.v3);
					Constant.v3 = Constant.v3+0;}
					else if(Constant.currentValue==1&&Constant.v3>=9){
					Util.setButton(true,TableParameters.rlr_h3, Constant.v3);
					Constant.v3 = Constant.v3+0;}
					else if(Constant.currentValue==-1&&Constant.v3==0){
					Util.setButton(true,TableParameters.rlr_h3, 0);
					Constant.v3= 0;}
					else{
					Util.setButton(true,TableParameters.rlr_h3, Constant.v3+Constant.currentValue);
					Constant.v3 = Constant.v3+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_h3,0);
					 Constant.v3 = Constant.v3+Constant.currentValue;
					 } break;
				 
					 
			 case R.id.rlr_h2:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v2>=5){
					Util.setButton(true,TableParameters.rlr_h2, Constant.v2);
					Constant.v2 = Constant.v2+0;}
					else if(Constant.currentValue==1&&Constant.v2>=9){
					Util.setButton(true,TableParameters.rlr_h2, Constant.v2);
					Constant.v2 = Constant.v2+0;}
					else if(Constant.currentValue==-1&&Constant.v2==0){
					Util.setButton(true,TableParameters.rlr_h2, 0);
					Constant.v2 = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_h2, Constant.v2+Constant.currentValue);
					Constant.v2 = Constant.v2+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_h2,0);
					 Constant.v2 = Constant.v2+Constant.currentValue;
					 } break;
				 
			 case R.id.rlr_h1:
				 if (Constant.currentValue!=0){
					if(Constant.currentValue>=5&&Constant.v1>=5){
					Util.setButton(true,TableParameters.rlr_h1, Constant.v1);
					Constant.v1 = Constant.v1+0;}
					else if(Constant.currentValue==1&&Constant.v1>=9){
					Util.setButton(true,TableParameters.rlr_h1, Constant.v1);
					Constant.v1 = Constant.v1+0;}
					else if(Constant.currentValue==-1&&Constant.v1==0){
					Util.setButton(true,TableParameters.rlr_h1, 0);
					Constant.v1 = 0;}
					else{
					Util.setButton(true,TableParameters.rlr_h1, Constant.v1+Constant.currentValue);
					Constant.v1 = Constant.v1+Constant.currentValue;}
				 } 
				 else if (Constant.currentValue==0){
					 Util.setButton(true,TableParameters.rlr_h1,0);
					 Constant.v1 = Constant.v1+Constant.currentValue;
					 } break;
		}}};
		
		
		 //TODO
		 private OnLongClickListener l2 = new OnLongClickListener(){
	        @Override
			public boolean onLongClick(View v) {
			switch(v.getId()){
			 case R.id.rlr_2v4:
				 Constant.v4s=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_2v4);
				 break;
			 case R.id.rlr_2v3:
				 Constant.v3s=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_2v3);
				 break;
			 case R.id.rlr_2v2:
				 Constant.v2s=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_2v2);
				 break;
			 case R.id.rlr_2v1:
				 Constant.v1s=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_2v1);
				 break;
				 
			 case R.id.rlr_h4:
				 Constant.v4=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_h4);
				 break;
			 case R.id.rlr_h3:
				 Constant.v3=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_h3);
				 break;
			 case R.id.rlr_h2:
				 Constant.v2=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_h2);
				 break;
			 case R.id.rlr_h1:
				 Constant.v1=0;
				 Util.setNullBackground(getActivity(),TableParameters.rlr_h1);
				 break;
			}return true;
			}};
}
