package com.univ.abacomaya.logic;


import android.app.Activity;
import android.content.Context;
import android.widget.Toast;

import com.univ.abacomaya.Constant;
import com.univ.abacomaya.MainActivity;
import com.univ.abacomaya.R;
import com.univ.abacomaya.interfaces.TableParameters;

public class UtilSum extends Activity {
	
	/**
	 * Metodo di controllo e che calcola gli steps totali e somma gli addendi. Se nei tab sono presenti numeri diversi da zero, il comando prosegue; se è uguale a zero
	 * viene segnalato l'errore all'utente. 
	 * @param Context c
	 */
	public static void sum(Context c) {
		int sum=Constant.v2_1+Constant.v2_2+Constant.v2_3+Constant.v2_4+Constant.v3_1+Constant.v3_2+ 
				Constant.v3_3+Constant.v3_4+Constant.v4_1+Constant.v4_2+Constant.v4_3+Constant.v4_4;
		if (sum>0){ sumCalc();
		TableParameters.setClickable1(false);
		
		 if (Constant.v4_4==0&&Constant.v4_3==0&&Constant.v4_2==0&&Constant.v4_1==0){Util.row0=0;}
		 else if (Constant.v4_4==0&&Constant.v4_3==0&&Constant.v4_2==0&&Constant.v4_1>0){Util.row0=1;}
		 else if (Constant.v4_4==0&&Constant.v4_3==0&&Constant.v4_2>0){Util.row0=2;}
		 else if (Constant.v4_4==0&&Constant.v4_3>0){Util.row0=3;}
		 else if (Constant.v4_4>0){Util.row0=4;}
		 if (Constant.v3_4==0&&Constant.v3_3==0&&Constant.v3_2==0&&Constant.v3_1==0){Util.row1=0;}
		 else if (Constant.v3_4==0&&Constant.v3_3==0&&Constant.v3_2==0&&Constant.v3_1>0){Util.row1=1;}
		 else if (Constant.v3_4==0&&Constant.v3_3==0&&Constant.v3_2>0){Util.row1=2;}
		 else if (Constant.v3_4==0&&Constant.v3_3>0){Util.row1=3;}
		 else if (Constant.v3_4>0){Util.row1=4;}
		 if (Constant.v2_4==0&&Constant.v2_3==0&&Constant.v2_2==0&&Constant.v2_1==0){Util.row2=0;}
		 else if (Constant.v2_4==0&&Constant.v2_3==0&&Constant.v2_2==0&&Constant.v2_1>0){Util.row2=1;}
		 else if (Constant.v2_4==0&&Constant.v2_3==0&&Constant.v2_2>0){Util.row2=2;}
		 else if (Constant.v2_4==0&&Constant.v2_3>0){Util.row2=3;}
		 else if (Constant.v2_4>0){Util.row2=4;}
				
		Constant.maxStep = 1 + Math.max(Math.max(Util.row0, Util.row1), Util.row2);
		Util.setSteps();
		}
		else if (sum==0){
		TableParameters.setClickable1(true);
		Toast.makeText(c, MainActivity.s.getString(R.string.c_insert), Toast.LENGTH_LONG).show();
	}}

	/**
	 * Calcola i valori dell'addizione		
	 */
	private static void sumCalc(){
		String s4_4 = String.valueOf(Constant.v4_4);
		String s4_3 = String.valueOf(Constant.v4_3);
		String s4_2 = String.valueOf(Constant.v4_2);
		String s4_1 = String.valueOf(Constant.v4_1);
		Util.s4 = (""+s4_4+s4_3+s4_2+s4_1);
		String s3_4 = String.valueOf(Constant.v3_4);
		String s3_3 = String.valueOf(Constant.v3_3);
		String s3_2 = String.valueOf(Constant.v3_2);
		String s3_1 = String.valueOf(Constant.v3_1);
		Util.s3 = (""+s3_4+s3_3+s3_2+s3_1);
		String s2_4 = String.valueOf(Constant.v2_4);
		String s2_3 = String.valueOf(Constant.v2_3);
		String s2_2 = String.valueOf(Constant.v2_2);
		String s2_1 = String.valueOf(Constant.v2_1);
		Util.s2 = (""+s2_4+s2_3+s2_2+s2_1); 	
				 
		Constant.sumResult = (Integer.parseInt(Util.s4))+(Integer.parseInt(Util.s3))+(Integer.parseInt(Util.s2));
		String result = String.valueOf(Constant.sumResult);
		int i=result.length();
		if (i==5){
			char c0 = result.charAt(0); Constant.v1v= Integer.parseInt(""+c0); 
			char c1 = result.charAt(1); Constant.v4= Integer.parseInt(""+c1); 
			char c2 = result.charAt(2); Constant.v3= Integer.parseInt(""+c2); 
			char c3 = result.charAt(3); Constant.v2= Integer.parseInt(""+c3); 
			char c4 = result.charAt(4); Constant.v1= Integer.parseInt(""+c4); 
		}
		else if (i==4){
			char c0 = result.charAt(0); Constant.v4= Integer.parseInt(""+c0); 
			char c1 = result.charAt(1); Constant.v3= Integer.parseInt(""+c1); 
			char c2 = result.charAt(2); Constant.v2= Integer.parseInt(""+c2); 
			char c3 = result.charAt(3); Constant.v1= Integer.parseInt(""+c3); 
		}
		else if (i==3){
			char c0 = result.charAt(0); Constant.v3= Integer.parseInt(""+c0); 
			char c1 = result.charAt(1); Constant.v2= Integer.parseInt(""+c1); 
			char c2 = result.charAt(2); Constant.v1= Integer.parseInt(""+c2); 
		}
		else if (i==2){
			char c0 = result.charAt(0); Constant.v2= Integer.parseInt(""+c0); 
			char c1 = result.charAt(1); Constant.v1= Integer.parseInt(""+c1); 
		}
		else if (i==1){
			char c0 = result.charAt(0); Constant.v1= Integer.parseInt(""+c0); 
	  }}
			
	
	/**
	 * Imposta i valori grafici degli Steps dell'addizione	   
	 */
	public static void showStepSum(){
		switch(Constant.currentStep){
	 case 0: Constant.s_step=""; 
	    Util.hideTable(TableParameters.rlr_hr1_pal);
	    Util.hideTable(TableParameters.rlr_hr2_pal);
	    Util.hideTable(TableParameters.rlr_hr3_pal);
	    Util.hideTable(TableParameters.rlr_hr4_pal);
	    Util.hideTable(TableParameters.rlr_hr1_frij);
	    Util.hideTable(TableParameters.rlr_hr2_frij);
	    Util.hideTable(TableParameters.rlr_hr3_frij);
	    Util.hideTable(TableParameters.rlr_hr4_frij);
	 return;
	 
	 case 1: 
		Constant.s_step= MainActivity.s.getString(R.string.a_t1);
		showResultSum();
		PartialRecollection.partialRec(Constant.v4_4, Constant.v3_4, Constant.v2_4, TableParameters.rlr_hr4_pal, TableParameters.rlr_hr4_frij);
		PartialRecollection.partialRec(Constant.v4_3, Constant.v3_3, Constant.v2_3, TableParameters.rlr_hr3_pal, TableParameters.rlr_hr3_frij);
		PartialRecollection.partialRec(Constant.v4_2, Constant.v3_2, Constant.v2_2, TableParameters.rlr_hr2_pal, TableParameters.rlr_hr2_frij);
		PartialRecollection.partialRec(Constant.v4_1, Constant.v3_1, Constant.v2_1, TableParameters.rlr_hr1_pal, TableParameters.rlr_hr1_frij);
		Util.hideTable(TableParameters.rlr_h1);
		Util.hideTable(TableParameters.rlr_h2);
		Util.hideTable(TableParameters.rlr_h3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1); return;
	 case 2: sumCol(3); return;
	 case 3: sumCol(2); return;
	 case 4: sumCol(1); return;
	 case 5: sumCol(0); return;
	}}
		 
	/**
	 * Imposta i valori grafici degli Steps dell'addizione		 
	 * @param int col
	 */
	private static void sumCol(int col){
		switch(col){
	 case 3:
		Util.value=(Constant.v4_1+Constant.v3_1+Constant.v2_1);
		Util.cell=1;
	  if (Util.value<=9){
		Constant.s_step = MainActivity.s.getString(R.string.a_t2)+Util.cell+MainActivity.s.getString(R.string.a_t3)+Util.cell+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h1,Constant.v1);
		Util.hideTable(TableParameters.rlr_h2);
		Util.hideTable(TableParameters.rlr_h3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum(); }
	  else if (Util.value>9){
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+" e "+(Util.cell+1)+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h1,Constant.v1);
		Util.setButton(false,TableParameters.rlr_h2,Constant.v2);
		Util.hideTable(TableParameters.rlr_h3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum(); 
	  } return;
			  
	case 2:	
		Util.value=(Constant.v4_2+Constant.v3_2+Constant.v2_2);
		Util.d = Util.value/10; Util.cell = 4-col;
	  if(Util.d>0){
		if(col > 0){
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+" e "+(Util.cell+1)+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h2,Constant.v2);
		Util.setButton(false,TableParameters.rlr_h3,Constant.v3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
	    } else {
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+MainActivity.s.getString(R.string.a_t7);
		Util.setButton(false,TableParameters.rlr_h2,Constant.v2);
		Util.hideTable(TableParameters.rlr_h3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
	    }
	  } else {
		Constant.s_step = MainActivity.s.getString(R.string.a_t2)+Util.cell+MainActivity.s.getString(R.string.a_t3)+Util.cell+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h2,Constant.v2);
		Util.hideTable(TableParameters.rlr_h3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
	  } return;
				
	case 1:
		Util.value=(Constant.v4_3+Constant.v3_3+Constant.v2_3);
		Util.d = Util.value/10; Util.cell = 4-col;
	  if(Util.d>0){
		if(col > 0){
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+" e "+(Util.cell+1)+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h3,Constant.v3);
		Util.setButton(false,TableParameters.rlr_h4,Constant.v4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
		} else {
	    Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+MainActivity.s.getString(R.string.a_t7);
		Util.setButton(false,TableParameters.rlr_h3,Constant.v3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
		}
	  } else {
		Constant.s_step = MainActivity.s.getString(R.string.a_t2)+Util.cell+MainActivity.s.getString(R.string.a_t3)+Util.cell+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h3,Constant.v3);
		Util.hideTable(TableParameters.rlr_h4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
	  } return;
			 
	case 0:
      Util.value=(Constant.v4_4+Constant.v3_4+Constant.v2_4);
	  Util.d = Util.value/10; Util.cell = 4-col;
	  if(Util.d>0){
		if(col > 0){
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+" e "+(Util.cell+1)+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h4,Constant.v4);
		Util.setButton(false,TableParameters.rlr_1,Constant.v1v);
		showResultSum();
		} else {
		Constant.s_step = MainActivity.s.getString(R.string.a_t5)+Util.cell+MainActivity.s.getString(R.string.a_t6)+Util.cell+MainActivity.s.getString(R.string.a_t7);
		Util.setButton(false,TableParameters.rlr_h4,Constant.v4);
		Util.setButton(false,TableParameters.rlr_1,Constant.v1v);
		showResultSum();
		}
	  } else {
		Constant.s_step = MainActivity.s.getString(R.string.a_t2)+Util.cell+MainActivity.s.getString(R.string.a_t3)+Util.cell+MainActivity.s.getString(R.string.a_t4);
		Util.setButton(false,TableParameters.rlr_h4,Constant.v4);
		Util.hideTable(TableParameters.rlr_1);
		showResultSum();
	  } return;
	}}
		 
		 
	/**
	 * Imposta il risultato dell'addizione
	 */
	private static void showResultSum(){
		if(Constant.currentStep<Constant.maxStep){
		Util.showsDialog(); }
		else if (Constant.currentStep==Constant.maxStep){
		Constant.s_step += "\n"+MainActivity.s.getString(R.string.a_t8) +Util.s4+"+"+Util.s3+"+"+Util.s2+MainActivity.s.getString(R.string.a_t9)+String.valueOf(Constant.sumResult)+".";
		Util.showsDialog(); }
	}
	

}
